import type { ValidationErrors } from '../exceptions/domain/validation';
import type Entity from '.';
export default abstract class Collection<T extends Entity> {
    private readonly collections;
    private static _isCreating;
    /**
     * @deprecated create 経由で生成
     */
    constructor(collections: Array<T>);
    [Symbol.iterator](): IterableIterator<T>;
    isEmpty(): boolean;
    validate(prev?: Collection<T>): ValidationErrors | undefined;
    static create<T extends Entity, Instance extends Collection<T>>(this: new (collections: T[]) => Instance, collections: T[]): Instance;
}
