"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isNumeric_1 = __importDefault(require("validator/lib/isNumeric"));
const _1 = __importDefault(require("."));
class Float extends _1.default {
    fromInput() {
        if (typeof this.input === 'number') {
            return this.input;
        }
        let num = parseFloat(this.input);
        const max = this.getMaxNumber();
        if (max !== undefined && num > max && this.isTruncateMode()) {
            num = Math.min(max, num);
        }
        const min = this.getMinNumber();
        if (min !== undefined && num < min && this.isTruncateMode()) {
            num = Math.max(min, num);
        }
        return num;
    }
    getMaxNumber() {
        return undefined;
    }
    getMinNumber() {
        return undefined;
    }
    isTruncateMode() {
        return false;
    }
    validate(name) {
        if (typeof this.input === 'string' && !(0, isNumeric_1.default)(this.input)) {
            return [{ name, error: '数値の形式が正しくありません' }];
        }
        const num = this.fromInput();
        const max = this.getMaxNumber();
        if (max !== undefined && num > max) {
            return [{ name, error: `${max}以下の値を入力してください` }];
        }
        const min = this.getMinNumber();
        if (min !== undefined && num < min) {
            return [{ name, error: `${min}以上の値を入力してください` }];
        }
        return undefined;
    }
    compare(value) {
        const diff = this.value - value.value;
        if (diff < 0)
            return -1;
        if (diff > 0)
            return 1;
        return 0;
    }
}
exports.default = Float;
//# sourceMappingURL=float.js.map