"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-non-null-assertion,@typescript-eslint/no-explicit-any */
const invalidUsage_1 = __importDefault(require("../exceptions/domain/invalidUsage"));
class ValueObject {
    // create メソッドの this コンテキストのせいで protected にはできない
    /**
     * @deprecated create 経由で生成
     */
    constructor(_input) {
        this._input = _input;
        this._setInner = false;
        this._setOutput = false;
        if (!ValueObject._isCreating) {
            throw new invalidUsage_1.default();
        }
    }
    fromInput() {
        return this.input;
    }
    toOutput() {
        return this.inner;
    }
    get input() {
        return this._input;
    }
    get inner() {
        if (!this._setInner) {
            this._setInner = true;
            this._inner = this.fromInput();
        }
        return this._inner;
    }
    get value() {
        if (!this._setOutput) {
            this._setOutput = true;
            this._output = this.toOutput();
            Object.freeze(this._output);
        }
        return this._output;
    }
    equals(value) {
        return this.compare(value) === 0;
    }
    static create(value) {
        try {
            ValueObject._isCreating = true;
            return new this(value);
        }
        finally {
            ValueObject._isCreating = false;
        }
    }
}
exports.default = ValueObject;
ValueObject._isCreating = false;
//# sourceMappingURL=index.js.map