"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isInt_1 = __importDefault(require("validator/lib/isInt"));
const float_1 = __importDefault(require("./float"));
class Int extends float_1.default {
    fromInput() {
        return Math.floor(super.fromInput());
    }
    validate(name) {
        const results = super.validate(name);
        if (results === null || results === void 0 ? void 0 : results.length) {
            return results;
        }
        if (typeof this.input === 'string' && !(0, isInt_1.default)(this.input)) {
            return [{ name, error: '整数の形式が正しくありません' }];
        }
        const num = this.fromInput();
        if (!Number.isSafeInteger(num)) {
            return [{ name, error: '有効な整数ではありません' }];
        }
        return undefined;
    }
}
exports.default = Int;
//# sourceMappingURL=int.js.map