"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const invalidValue_1 = __importDefault(require("../exceptions/domain/invalidValue"));
const _1 = __importDefault(require("."));
class StringId extends _1.default {
    fromInput() {
        if (this.input === null) {
            return null;
        }
        return `${this.input}`;
    }
    toOutput() {
        if (this.inner === null) {
            throw new invalidValue_1.default('id');
        }
        return super.toOutput();
    }
    validate(name) {
        const text = this.fromInput();
        if (text === null) {
            return undefined;
        }
        if (!text.length) {
            return [{ name, error: '値を指定してください' }];
        }
        return undefined;
    }
    compare(value) {
        return this.value.localeCompare(value.value);
    }
}
exports.default = StringId;
//# sourceMappingURL=stringId.js.map